"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "Filter", {
  enumerable: true,
  get: function get() {
    return _Filter["default"];
  }
});
exports["default"] = exports.createInstance = void 0;

var _axios = _interopRequireDefault(require("axios"));

var _useRequestURLEncoded = _interopRequireDefault(require("./useRequestURLEncoded"));

var _useRequestFilter = _interopRequireDefault(require("./useRequestFilter"));

var _useResponseError = _interopRequireDefault(require("./useResponseError"));

var _useResponseFilter = _interopRequireDefault(require("./useResponseFilter"));

var _Filter = _interopRequireDefault(require("./Filter"));

/**
 * @name: ajax ;
 * @author: lingtong ;
 * @description: axios的封装实现了filter ;
 * */
var createInstance = function createInstance(preset) {
  var ajax = _axios["default"].create({
    validateStatus: function validateStatus() {
      return true;
    }
  });

  ajax.interceptors.request.use(_useRequestURLEncoded["default"]);
  ajax.interceptors.request.use(_useRequestFilter["default"]);
  ajax.interceptors.response.use(_useResponseError["default"]);
  ajax.interceptors.response.use(_useResponseFilter["default"]);
  preset && typeof preset === 'function' && preset(ajax);
  return ajax;
};

exports.createInstance = createInstance;

var _default = createInstance();

exports["default"] = _default;